# hpc-ai-ml-2019
This repository holds the computer labs for the Introduction to Machine Learning course of the 2019-2020 HPC-AI MSc 
https://www.hpc-ai.mines-paristech.fr/

## Requirements
The labs were developed for Python3. All required packages are part of the [Anaconda platform](https://www.anaconda.com/download/) so you can simply install Anaconda3 on your machine. If you'd rather install just the required packages with pip, that is also possible. The labs were developed for Python 3.4.3, with the following libraries:
* numpy 1.16.5
* scipy 1.2.2
* matplotlib 2.2.4
* pandas 0.22.0
* seaborn 0.9.0
* sklearn 0.19.2

To __check your installation__, try launching Jupyter (e.g. by typing `jupyter noteboook` in a shell), navigating to where you have downloaded/pulled the first lab (.ipynb file) and opening it. In that notebook (or in a python terminal), you should be able to run 
  ```python
  import sklearn
  import pandas
  import seaborn
  import matplotlib
  ```

## Program
* Lab 1: [Principal Component Analysis](https://github.com/chagaz/hpc-ai-ml-2019/blob/master/01-PCA.ipynb) (1h)
* Lab 2: [Data normalization](https://github.com/chagaz/hpc-ai-ml-2019/blob/master/02-FeatureProcessing.ipynb) (1h)
* Lab 3: [Introduction to the KaggleInClass project](https://github.com/chagaz/hpc-ai-ml-2019/blob/master/03-ProjectIntro.ipynb) (2h)
* Lab 4: [Linear and logistic regression](https://github.com/chagaz/hpc-ai-ml-2019/blob/master/04-Linear%20and%20logistic%20regressions.ipynb) (1h) 
* Lab 5: [Regularized linear regression](https://github.com/chagaz/hpc-ai-ml-2019/blob/master/05-Regularization.ipynb) (1h) 
* Lab 6: [Nearest neighbors](https://github.com/chagaz/hpc-ai-ml-2019/blob/master/06-NearestNeighbors.ipynb) (1h) 
* Lab 7: [Trees and Forests](https://github.com/chagaz/hpc-ai-ml-2019/blob/master/07-TreesAndForests.ipynb) (1h) 
* Lab 8: [Support Vector Machines](https://github.com/chagaz/hpc-ai-ml-2019/blob/master/08-SVM.ipynb) (1h)
* Lab 9: Work on the project (3h) 


### Acknowledgements
These notebooks are adapted from notebooks previously created with the help of Judith Abecassis, Joseph Boyd, Arthur Imber, Benoit Playe and Mihir 
